<!DOCTYPE html>
<html>

<head>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>
    <div class="container-fluid jumbotron">
        <div class="row d-flex align-items-center min-vh-100 p-5">
            <div class="col-md-12 mx-auto my-0 jumbotron bg-white p-5 px-5 signup-form">
                <div class="form-group">
                    <h2>Sign-up</h3>
                    <p>Please fill in this form to create an account</p>
                </div>
                <hr>
                <div class="row">
                    <div class="col-sm-6">
                        <div class="form-group">
                            <input type="text" class="form-control" id="inp-firstname" placeholder="First name">
                        </div>
                    </div>
                    <div class="col-sm-6">
                        <div class="form-group">
                            <input type="text" class="form-control" id="inp-lastname" placeholder="Last name">
                        </div>
                    </div>
                </div>
                <div class="form-group">
                    <input type="email" class="form-control" id="inp-email" placeholder="Email">
                </div>
                <div class="form-group">
                    <input type="password" class="form-control" id="inp-password" placeholder="Password" required>
                </div>
                <div class="form-group">
                    <input type="password" class="form-control" id="inp-repeat-password" placeholder="Confirm Password" required>
                </div>
                <div class="form-group">
                    <input type="checkbox" id="ckb-agree">
                    I accept the Terms of use & privacy policy
                </div>
                <div class="form-group">
                    <button id="btn-sign-up" class="btn btn-primary">Sign up</button>
                </div>
            </div>
        </div>
    </div>
    <!-- Modal show message-->
    <div class="modal fade" id="modal-message">
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title">Thong bao</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close" >
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <h6 id="message"></h6>
            </div>
            <div class="modal-footer">
              <button type="button" class="btn btn-secondary" data-dismiss="modal">
                Close
              </button>
            </div>
          </div>
        </div>
      </div>
</body>
<script>
    //Vùng 1: định nghĩa global variable (biến toàn cục)

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $("#btn-sign-up").on("click", function() {
        onBtnSignUpClick();
    })

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onBtnSignUpClick() {
        //B1  Thu Thập Dữ Liệu
        var vUserData = readDataFromFormSignUp();
        //B2  Kiểm tra dữ liệu
        var vIsValid = validateData(vUserData);
        if(vIsValid) {
          //B3 call APi Đăng Nhập
          callAjaxApiSignUp(vUserData);
        }
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function readDataFromFormSignUp() {
        var vUserData = {
            firstname: $.trim($("#inp-firstname").val()),
            lastname: $.trim($("#inp-lastname").val()),
            email: $.trim($("#inp-email").val()),
            password: $.trim($("#inp-password").val()),
            repeatPassword: $.trim($("#inp-repeat-password").val()),
            iAgree: $("#ckb-agree").is(":checked")
        }
        return vUserData;
    };
    // B2 Kiem Tra Du Lieu 
    function validateData(paramData){
        var vIsValid = false;
        if(paramData.firstname == ""){
            showModalMessage("Chua Nhap Firstname")
        }
        else if(paramData.lastname == ""){
            showModalMessage("Chua Nhap Lastname")
        }
        else if(paramData.email == ""){
            showModalMessage("Chua Nhap Email")
        }
        else if(validateEmail(paramData.email) == false){
            showModalMessage("Email khong hop le")
        }
        else if(paramData.password == ""){
            showModalMessage("Chua Nhap Password")
        }
        else if(paramData.repeatPassword == ""){
            showModalMessage("Chua Nhap Lai Password")
        }
        else if(paramData.repeatPassword != paramData.password){
            showModalMessage("Nhap Lai Password chua dung")
        }
        else if(paramData.iAgree == false){
            showModalMessage("Phai chon o Dong y")
        }
        else 
            vIsValid = true;
        return vIsValid;
    }
    function validateEmail(paramEmail) {
        var vRegex = /^[^\s@]+@[^\s@]+\.[^\s@]+$/;
        return vRegex.test(paramEmail);
    }
    function showModalMessage(paramMessage) {
        "use strict";
        $("#message").html(paramMessage);
        $("#modal-message").modal("show");
    }
    function callAjaxApiSignUp(paramUserData){
        "use strict";
        $.ajax({
            url: "http://42.115.221.44:8080/devcamp-auth/users/signup",
            type: 'POST',
            async: false,
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            data: JSON.stringify(paramUserData),
            success: function (pRes) {
                showModalMessage("Signup thanh cong. Xem console");
                console.log(pRes)
            },
            error: function (pAjaxContext) {
                showModalMessage("Signup khong thanh cong. Xem console")
                console.log(pAjaxContext.responseJSON.message);
            }
        });
    }

</script>
</html>